// symetric level generator for BedPoing!
program Generator1;

uses SysUtils;
{$R *.RES}

type TSection = array[1..20,1..7] of integer;
type TField = array[1..80,1..14] of integer;

function GenerateSection : TSection;
var section : TSection;
    x,y : integer;
    f : textfile;
    temp : string;
    numberofsections : integer;
begin
     numberofsections:=1;
     while fileexists(extractfilepath(paramstr(0))+'\sections\section'+inttostr(numberofsections)+'.bps') do inc(numberofsections);
     assignfile(f,extractfilepath(paramstr(0))+'\sections\section'+inttostr(random(numberofsections-1)+1)+'.bps');
     reset(f);
     for y:=1 to 7 do
     begin
          readln(f,temp);
          for x:=1 to 20 do
          begin
               section[x,y]:=strtoint(temp[x]);
          end;
     end;
     closefile(f);
     result:=section;
end;

procedure GenerateLevel(filename : string);
var f : textfile;
    x,y : integer;
    field : TField;
    section : TSection;
    counter : integer;
begin
     //blank
     for x:=1 to 80 do
     begin
          for y:=1 to 14 do
          begin
               field[x,y]:=0;
          end;
     end;
     counter:=20;
     repeat //sections
           Section:=GenerateSection;
           for x:=1 to 20 do
           begin
                for y:=1 to 7 do
                begin
                     field[x+counter,y]:=section[x,y];
                     field[x+counter,y+7]:=section[x,y];
                end;
           end;
           inc(counter,20);
     until counter>60;
     assignfile(f,filename);
     rewrite(f);
     for y:=1 to 14 do
     begin
          for x:=1 to 80 do
          begin
               write(f,field[x,y]);
          end;
          writeln(f);
     end;
     closefile(f);
end;


var x,Numlevels : integer;
    filename : string;

begin

     if not (ParamCount=1) then exit;
     randomize;
     Numlevels:=strtoint(paramstr(1));

     for x:=1 to NumLevels do
     begin
          filename:=extractfilepath(paramstr(0))+'level'+inttostr(x)+'.bpl';
          GenerateLevel(filename);
     end;

end.
